(* $Id: hydro_lm_IceObject.mli 15333 2007-11-23 16:41:36Z gerd $ *)

(** The default [::Ice::Object] *)

(** This modules is used by the generated language mapping layer to
    refer to [::Ice::Object], the root of the class hierarchy.
 *)

(** {1 Proxy view} *)

type proxy_name = [ `Ice_Object ]
and pr_Ice_Object = [ `Ice_Object ] Hydro_lm.proxy_reference

val ofpr_Ice_Object : pr_Ice_Object option -> Hydro_types.value
val topr_Ice_Object : Hydro_types.value -> pr_Ice_Object option

(* To be extended. We only have [ice_ping] for now. *)

class type r_Ice_Object_ice_ping =
object
  method hydro_response : Hydro_lm.client_response
  method result : unit
end


val to_r_Ice_Object_ice_ping :
    Hydro_lm.client_response -> r_Ice_Object_ice_ping


class type poi_Ice_Object =
object
  method ice_ping : unit -> r_Ice_Object_ice_ping Hydro_lm.call_suspension_t
end


class type po_Ice_Object =
object
  inherit Hydro_proxy.proxy_t
  inherit poi_Ice_Object
  method hydro_proxy_reference : pr_Ice_Object
end


class pci_Ice_Object :
  Hydro_proxy.proxy_t -> poi_Ice_Object

val pc_Ice_Object :
  Hydro_proxy.proxy_env_t -> pr_Ice_Object -> po_Ice_Object

val unchecked_pr_Ice_Object :
  't Hydro_lm.proxy_reference -> pr_Ice_Object

(*
val checked_pr_Ice_Object :
  't Hydro_lm.proxy_reference -> pr_Ice_Object
 *)

type or_Ice_Object

class type od_Ice_Object =
object
  method facets : unit ref (* dummy method - this data member is unused *)
end

class type o_Ice_Object =
object
  (* Note: Operations are unimplemented *)
  inherit od_Ice_Object
  inherit Hydro_lm.object_base
end

exception O_Ice_Object of o_Ice_Object

val as_Ice_Object : #Hydro_lm.object_base -> o_Ice_Object
val wrap_Ice_Object : o_Ice_Object -> or_Ice_Object
val unwrap_Ice_Object : or_Ice_Object -> o_Ice_Object

val ofor_Ice_Object : or_Ice_Object -> Hydro_types.value
val toor_Ice_Object : Hydro_types.value -> or_Ice_Object

class delegate_od_Ice_Object : #od_Ice_Object -> od_Ice_Object

val dec_Ice_Object : Hydro_types.slice list -> 
                         unit * Hydro_types.slice list

val enc_Ice_Object : #od_Ice_Object -> Hydro_types.slice list

class mk_od_Ice_Object : unit -> od_Ice_Object

class sliced_od_Ice_Object : #od_Ice_Object -> Hydro_lm.sliced_base

class mk_Ice_Object : #od_Ice_Object -> o_Ice_Object

class restore_Ice_Object : Hydro_types.sliced_value -> o_Ice_Object

val defterm_Ice_Object : Hydro_types.hintf Lazy.t

val class_defterm_Ice_Object : Hydro_types.hclass Lazy.t

val fill_system : Hydro_types.system -> unit

